unit export;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, Mask, ToolEdit;

type
  Tf_export = class(TForm)
    de_output: TDirectoryEdit;
    Label1: TLabel;
    cmb_of: TComboBox;
    Label2: TLabel;
    sb_go: TSpeedButton;
    sb_close: TSpeedButton;
    procedure sb_closeClick(Sender: TObject);
    procedure sb_goClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure de_outputExit(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  f_export: Tf_export;

implementation

uses main, sledit, constants, reguse;

{$R *.DFM}

function fileexists(fname: string): boolean;
var f    : tsearchrec;
    attr : integer;
begin
    attr:= fareadonly+fahidden+faarchive;
    fileexists:= (findfirst(fname, attr, f) = 0);
    findclose(f);
end;

function get_noext(s: string): string;
var
   i,
   j : integer;
   x : string;
begin
     s:= extractfilename(s);
     i:= length(s);
     x:= '';
     while s[i]<>'.' do i:= i-1;
     for j:= 1 to i-1 do x:= x+s[j];
     get_noext:= x;
end;

function getname_fromimg(s: string): string;
var i : integer;
    x : string;
begin
     x:= '';
     for i:= 1 to 9 do begin
      if not(
             (s[i] in ['0'..'9']) or
             (s[i] in ['A'..'Z']) or
             (s[i] in ['a'..'z'])) = true then s[i]:= '_';
      x:= x+s[i];
     end;
      getname_fromimg:= x;
end;


procedure Tf_export.sb_closeClick(Sender: TObject);
begin
     stop_it:= true;
     close;
end;


function ok_to_overwrite(xname: string): boolean;
var
    b : boolean;
begin
     b:= true;
     if fileexists(xname) then
     b:= (messagebox(0,
              pchar(format('''%s'' exists. OK to overwrite?', [xname])),
              'SpecView SE',
              MB_YESNO or MB_ICONQUESTION
              ) = idyes);
     ok_to_overwrite:= b;
end;

procedure Tf_export.sb_goClick(Sender: TObject);
var
   i       : integer;
   ifname,
   ofname  : string;
begin
     // "Close" button wasn't pressed
     stop_it:= false;


     for i:= 0 to f_sledit.lbx_list.items.count-1 do begin

      application.processmessages;
      if stop_it then begin
       messagebox(0,
                  'Operation interrupted',
                  'SpecView SE',
                  MB_ICONWARNING or MB_OK);
       exit;
      end;

      if f_sledit.lbx_list.selected[i] then begin
       ifname:= f_sledit.lbx_list.items[i];
       container_size:= f_main.readfile(ifname);

       // Can't read picture
       if (container_size = 0) or (container_size > 6929) then
        messagebox(0,
                   pchar(ifname+' - '+m_corr),
                   'SpecView SE',
                   MB_OK or MB_ICONERROR)
        // All is OK
        else begin

         f_main.makepic(container_size);

         ofname:= de_output.text;

         // Determine output file name...
         if use_image then ofname:= ofname+getname_fromimg(ifname)
         else ofname:= ofname+get_noext(ifname);

         // ... and extension
         case cmb_of.itemindex of
          0: ofname:= ofname+'.bmp';
          1: ofname:= ofname+'.jpg';
          2: ofname:= ofname+'.gif';
         end;

         // Make export
         if ok_to_overwrite(ofname) then
          case cmb_of.itemindex of
           0: f_main.i_speccy.picture.savetofile(ofname);
           1: f_main.saveJPEG(ofname, f_main.i_speccy);
           2: f_main.saveGIF(ofname, f_main.i_speccy);
          end;

        end;

      end;

      end;
      messagebox(windowhandle,
                 'Export completed.',
                 'SpecView SE',
                 MB_ICONINFORMATION or MB_OK);
end;

procedure Tf_export.FormClose(Sender: TObject; var Action: TCloseAction);
var
   lkey : string;
begin
     lkey:= 'Software\HA\SpecView SE';
     wrt_reg(HKEY_CURRENT_USER, lkey, 'OutputFormat', inttostr(cmb_of.itemindex), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'ExpTop', inttostr(top), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'ExpLeft', inttostr(left), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'ExportDir', de_output.text, true);
end;

procedure Tf_export.FormCreate(Sender: TObject);
var
    a,
    c    : integer;
    lkey : string;
begin
     lkey:= 'Software\HA\SpecView SE';
     if read_reg(HKEY_CURRENT_USER, lkey, 'FirstTime') = '0' then begin
      val(read_reg(HKEY_CURRENT_USER, lkey, 'OutputFormat'), a, c);
      cmb_of.itemindex:= a;
      val(read_reg(HKEY_CURRENT_USER, lkey, 'ExpTop'), a, c);
      top:= a;
      val(read_reg(HKEY_CURRENT_USER, lkey, 'ExpLeft'), a, c);
      left:= a;
      de_output.text:= read_reg(HKEY_CURRENT_USER, lkey, 'ExportDir');
     end else cmb_of.itemindex:= 0;
end;

procedure Tf_export.de_outputExit(Sender: TObject);
var
   s : string;
begin
        s:= de_output.text;
        if s<>'' then begin if s[length(s)] <> '\' then s:= s+'\'; end
        else s:= s+'\';
        de_output.text:= s;
end;

end.
