unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Menus, ToolWin, registry, printers, jpeg,
  ImgList, RXGif;

type
  Tf_main = class(TForm)
    i_speccy: TImage;
    dlg_open: TOpenDialog;
    MainMenu1: TMainMenu;
    m_file: TMenuItem;
    m_open: TMenuItem;
    m_export: TMenuItem;
    N1: TMenuItem;
    m_print: TMenuItem;
    m_tuneprinter: TMenuItem;
    N2: TMenuItem;
    m_exit: TMenuItem;
    m_tools: TMenuItem;
    m_colors: TMenuItem;
    m_window: TMenuItem;
    m_slideshow: TMenuItem;
    N3: TMenuItem;
    m_register: TMenuItem;
    m_bright: TMenuItem;
    m_color: TMenuItem;
    m_pallette: TMenuItem;
    m_zoomin: TMenuItem;
    m_zoomout: TMenuItem;
    m_original: TMenuItem;
    m_double: TMenuItem;
    N4: TMenuItem;
    m_htool: TMenuItem;
    m_hprogress: TMenuItem;
    m_full: TMenuItem;
    m_new: TMenuItem;
    N5: TMenuItem;
    m_rescan: TMenuItem;
    m_next: TMenuItem;
    m_prev: TMenuItem;
    m_shortcuts: TMenuItem;
    m_help: TMenuItem;
    m_about: TMenuItem;
    m_docs: TMenuItem;
    m_home: TMenuItem;
    ImageList1: TImageList;
    t_main: TToolBar;
    tb_open: TToolButton;
    tb_export: TToolButton;
    tb_print: TToolButton;
    ToolButton4: TToolButton;
    tb_zoomin: TToolButton;
    tb_zoomout: TToolButton;
    tb_prev: TToolButton;
    tb_next: TToolButton;
    tb_rescan: TToolButton;
    ToolButton10: TToolButton;
    tb_discard: TToolButton;
    ToolButton12: TToolButton;
    tb_tools: TToolButton;
    pn_progress: TPanel;
    pb_progress: TProgressBar;
    dlg_save: TSaveDialog;
    dlg_print: TPrintDialog;
    N6: TMenuItem;
    m_usesl: TMenuItem;
    m_sledit: TMenuItem;
    m_inv: TMenuItem;
    N7: TMenuItem;
    m_wall: TMenuItem;
    m_wtiled: TMenuItem;
    m_wcentered: TMenuItem;
    Stretch1: TMenuItem;
    m_rmv: TMenuItem;
    m_expfolder: TMenuItem;
    procedure tb_openClick(Sender: TObject);
    procedure m_doubleClick(Sender: TObject);
    procedure m_originalClick(Sender: TObject);
    procedure tb_zoominClick(Sender: TObject);
    procedure m_newClick(Sender: TObject);
    procedure tb_zoomoutClick(Sender: TObject);
    procedure tb_discardClick(Sender: TObject);
    procedure m_aboutClick(Sender: TObject);
    procedure tb_toolsClick(Sender: TObject);
    procedure m_tuneprinterClick(Sender: TObject);
    procedure m_exitClick(Sender: TObject);
    procedure i_speccyDblClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure m_registerClick(Sender: TObject);
    procedure m_palletteClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure m_brightClick(Sender: TObject);
    procedure m_htoolClick(Sender: TObject);
    procedure m_hprogressClick(Sender: TObject);
    procedure m_printClick(Sender: TObject);
    procedure tb_exportClick(Sender: TObject);
    procedure m_shortcutsClick(Sender: TObject);
    procedure m_docsClick(Sender: TObject);
    procedure m_homeClick(Sender: TObject);
    procedure tb_rescanClick(Sender: TObject);
    procedure tb_prevClick(Sender: TObject);
    procedure tb_nextClick(Sender: TObject);
    procedure m_sleditClick(Sender: TObject);
    procedure m_useslClick(Sender: TObject);
    procedure m_invClick(Sender: TObject);
    procedure m_wtiledClick(Sender: TObject);
    procedure m_wcenteredClick(Sender: TObject);
    procedure Stretch1Click(Sender: TObject);
    procedure m_rmvClick(Sender: TObject);
    procedure m_expfolderClick(Sender: TObject);
  private
    procedure getchunx(input_image: timage; const output_image: timage);
    function  get_color(atr: byte; spix_type: boolean): tcolor;
    procedure rescan_it(const flist: tlistbox; const sender: tobject);
    procedure next_p(const flist: tlistbox);
    procedure prev_p(const flist: tlistbox);
    procedure walldesk(style: byte);
    { Private declarations }
  public
    function  readfile(name: string): longint;
    procedure get_file(fname: string; const sender: tobject);
    procedure makepic(container_size: longint);
    procedure rescan_dir(directory: string);
    procedure saveJPEG(filename: string; const img: timage);
    procedure saveGIF(filename: string; const img: timage);
    { Public declarations }
  end;

var
  f_main: Tf_main;

implementation

{$R *.DFM}

uses constants, fmxutils, pref, full, reguse, sledit;

procedure Tf_main.getchunx(input_image: timage; const output_image: timage);
var
   i,
   j,
   c,
   x,
   y  : integer;
begin
     for x:= 0 to 63 do
      for y:= 0 to 47 do begin
       c:= 0;
       for i:= 0 to  3 do
        for j:= 0 to 3 do
         if input_image.canvas.pixels[x*4+i, y*4+j] <> spec_colors[1] then c:= c+16;
       if c > 255 then c:= 255;
       c:= rgb(c, c, c);
       output_image.canvas.pixels[x, y]:= c;
      end;
end;


procedure Tf_main.saveJPEG(filename: string; const img: timage);
var
   JPEG: tjpegimage;
begin
     JPEG:= tjpegimage.create;
     with JPEG do
     try
      if f_pref.cb_gs.checked then grayscale:= true
      else grayscale:= false;
      performance:= jpbestquality;
      assign(img.picture.bitmap);
      jpegneeded;
      savetofile(filename);
     finally
      free;
     end;
end;

procedure Tf_main.saveGIF(filename: string; const img: timage);
var
   GIF : tgifimage;
begin
     GIF:= tgifimage.create;
     with GIF do
     try
      assign(img.picture.bitmap);
      savetofile(filename);
     finally
      free;
     end;
end;

function tf_main.readfile(name: string): longint;
var
    f     : file of byte;
    ssize,
    where : longint;
    c,
    i     : integer;
    s     : string;
begin
     application.processmessages;
     pb_progress.position:= 0;
     {$I-}
     if (use_image = false) then begin
      assignfile(f, name);
      reset(f);
      if ioresult<>0 then begin
       readfile:= 0;
       exit;
      end;
      ssize:= filesize(f);
      if ssize > 6929 then begin
       readfile:= 0;
       closefile(f);
       exit;
      end;
     end else begin
      assignfile(f, f_sledit.dlg_open.filename);
      reset(f);
      if ioresult<>0 then begin
       readfile:= 0;
       exit;
      end;
      val(name[11]+name[12], ssize, c);
      ssize:= ssize*256;
      i:= length(name);
      s:= '';
      while name[i]<>';' do begin
       s:= name[i]+s;
       i:= i-1;
      end;
      val(s, where, c);
      seek(f, where);
     end;
     blockread(f, pic_container, ssize);
     closefile(f);
     readfile:= ssize;
     {$I+}
end;

function tf_main.get_color(atr: byte; spix_type: boolean): tcolor;
var
   a,
   b     : byte;
   ink,
   paper : tcolor;
begin
     asm
        mov al, atr
        and al, 56
        shr al, 3
        mov a,  al
        mov al, atr
        and al, 7
        mov b,  al
     end;
     if ((atr and 64)=0) or not(bright_on) then begin
      paper:= spec_colors[a+1];
      ink:= spec_colors[b+1];
     end
     else begin
      if a<>0 then paper:= spec_colors[a+8]
      else paper:= spec_colors[1];
      if b<>0 then ink:= spec_colors[b+8]
      else ink:= spec_colors[1];
     end;
     if spix_type then get_color:= paper
     else get_color:= ink;
end;

procedure tf_main.makepic(container_size: longint);
var
   i,
   j,
   line,
   skip_hdr,
   third          : byte;
   s_addr,
   temp_count     : word;
   atr_i,
   atr_p,
   t_color        : tcolor;
   temp_container : array [1..6144] of byte;
   im_container   : tbitmap;
begin
     if (container_size = 6929) or (container_size = 6161)
     then skip_hdr:= 17 else skip_hdr:= 0;
     if (container_size = 6144) or (container_size = 6161)
     then colors_on:= false else if m_color.checked = false then colors_on:= true;
     temp_count:= 6113;
     for third:= 0 to 2 do
      for line:= 0 to 7 do begin
       pb_progress.position:= pb_progress.position+line div 6;
       for i:= 0 to 7 do begin
        for j:= 0 to 31 do begin
         s_addr:= third*2048+line*32+256*i+1+j+skip_hdr;
         temp_container[temp_count]:= pic_container[s_addr];
         inc (temp_count, 1);
        end;
        dec (temp_count, 64);
       end;
      end;
     for temp_count:= 6145 to 6912 do
      if colors_on then begin
        atr_container[1, temp_count-6144]:= get_color(pic_container[temp_count+skip_hdr], false);
        atr_container[2, temp_count-6144]:= get_color(pic_container[temp_count+skip_hdr], true);
      end else begin
        atr_container[1, temp_count-6144]:= spec_colors[1];
        atr_container[2, temp_count-6144]:= spec_colors[15];
      end;
     temp_count:= 1;
     im_container:= tbitmap.create;
     try
      im_container.width:= 256;
      im_container.height:= 192;
      for line:= 191 downto 0 do begin
       pb_progress.position:= pb_progress.position+line div 88;
       for i:= 0 to 31 do begin
         atr_i:= atr_container[1, (line div 8)*32+i+1];
         atr_p:= atr_container[2, (line div 8)*32+i+1];
         if m_inv.checked then begin
          t_color:= atr_i;
          atr_i:= atr_p;
          atr_p:= t_color; 
         end;
       for j:= 7 downto 0 do
        if (temp_container[temp_count] and (1 shl j)) = 0 then im_container.Canvas.Pixels[i*8+7-j, line]:= atr_p
        else im_container.Canvas.Pixels[i*8+7-j, line]:= atr_i;
        temp_count:= temp_count+1;
       end;
      end;
      i_speccy.picture.bitmap:= im_container;
      if f_fullscreen.visible then f_fullscreen.i_fspeccy.picture.bitmap:= im_container;
     finally
      im_container.free;
     end;
end;

procedure Tf_main.get_file(fname: string; const sender: tobject);
var
   f_ext: string;
begin
       f_ext:= lowercase(extractfileext(fname));
       if (f_ext = '.shw') or (f_ext = '.trd') or (f_ext = '.scl')then begin
        f_sledit.readshow(fname);
        f_sledit.dlg_open.filename:= fname;
        f_sledit.upd_stbar;
        m_usesl.checked:= true;
        f_sledit.m_useinstead.checked:= true;
        if (f_ext = '.trd') or (f_ext = '.scl') then use_image:= true
        else use_image:= false;
        if f_pref.cb_start.checked then begin
         m_usesl.checked:= true;
         f_sledit.m_useinstead.checked:= true;
         tb_rescanclick(sender);
        end;
       end else begin
        use_image:= false;
        m_usesl.checked:= false;
        f_sledit.m_useinstead.checked:= false;
        pb_progress.position:= 0;
        container_size:= readfile(fname);
        if (container_size = 0) or (container_size > 6929) then
         messagedlg(fname+' - '+m_corr, mterror, [mbok], 0)
        else begin
         f_main.caption:= fname+' - SpecView SE';
         application.title:= fname+' - SpecView SE';
         makepic(container_size);
        end;
         f_pref.de_favor.text:= extractfilepath(fname);
       end;
end;

procedure Tf_main.tb_openClick(Sender: TObject);
begin
      if dlg_open.execute then get_file(dlg_open.filename, sender);
end;

procedure Tf_main.m_doubleClick(Sender: TObject);
begin
     windowstate:= wsnormal;
     height:= 462;
     width:=  520;
     if m_htool.checked then
     height:= height-t_main.height;
     if m_hprogress.checked then
     height:= height-pn_progress.height;
end;

procedure Tf_main.m_originalClick(Sender: TObject);
begin
     windowstate:= wsnormal;
     height:= 270;
     width:= 264;
     if m_htool.checked then
     height:= height-t_main.height;
     if m_hprogress.checked then
     height:= height-pn_progress.height;
end;

procedure Tf_main.tb_zoominClick(Sender: TObject);
begin
     if (height < screen.height) or (width < screen.width) then begin
      height:= height+192;
      width:=  width+256;
      tb_zoomout.enabled:= true;
     end else begin
      tb_zoomout.enabled:= true;
      tb_zoomin.enabled:=   false;
     end;
end;

procedure Tf_main.m_newClick(Sender: TObject);
begin
     executefile(paramstr(0), '', '', SW_SHOW);
end;

procedure Tf_main.tb_zoomoutClick(Sender: TObject);
begin
     if (height > 270) or (width > 264) then begin
      height:= height-192;
      width:=  width-256;
      tb_zoomin.enabled:=   true;
     if (height < 270) or (width < 264) then begin
      height:= 270;
      width:= 264;
     end;
     end else begin
      tb_zoomout.enabled:= false;
      tb_zoomin.enabled:=   true;
     end;

end;

procedure Tf_main.tb_discardClick(Sender: TObject);
begin
     pb_progress.position:= 0;
     m_color.checked:= not(m_color.checked);
     colors_on:= not(colors_on);
     makepic(container_size);
end;

procedure Tf_main.m_aboutClick(Sender: TObject);
begin
     messagebox(f_main.windowhandle, 'SpecView SE v. 2.2.1 ("Golden Leaves"; stable) - The ZX Spectrum Screenshot Viewer'+#10#13+
                ''+#10#13+
                'Program code is Copyright  1999-2001 by Sergei Dubarev'+#10#13+
                'Spectrum screenshots are Copyright  1999-2001 by Pro Hackers Dynasty'+#10#13+
                'See documentation for more information on copyrights.'+#10#13+
                ''+#10#13+
                'This program is a FREEWARE and cannot be sold.',
                'SpecView SE', MB_OK or MB_ICONINFORMATION);
end;

procedure Tf_main.tb_toolsClick(Sender: TObject);
begin
     f_pref.showmodal;
end;

procedure Tf_main.m_tuneprinterClick(Sender: TObject);
begin
     f_pref.pc_pref.activepage:= f_pref.ts_printer;
     f_pref.showmodal;
end;

procedure Tf_main.m_exitClick(Sender: TObject);
begin
     f_main.close;
end;

procedure Tf_main.i_speccyDblClick(Sender: TObject);
begin
      f_fullscreen.i_fspeccy.picture.bitmap:= i_speccy.picture.bitmap;
      f_fullscreen.show;
end;

procedure Tf_main.FormResize(Sender: TObject);
begin
     if (width <= 264) or (height <= 270) then tb_zoomout.enabled:= false
     else tb_zoomout.enabled:= true;
     if (width >= screen.width) or (height >= screen.height) then tb_zoomin.enabled:= false
     else tb_zoomin.enabled:= true;
     if windowstate = wsmaximized then begin
      tb_zoomin.enabled:= false;
      tb_zoomout.enabled:= false;
     end;
end;

procedure do_rescan(directory, fmask: string; attr: integer; const list: tstringlist);
var path : string;
    res  : integer;
    f    : tsearchrec;
begin
    path:= directory+'*.'+fmask;
    res := findfirst(path, attr, f);
    while res = 0 do
    begin
      if f.name[1]<>'.' then list.add(directory+f.name);
      res := findnext(f);
    end;
    findclose(f);
end;

procedure Tf_main.rescan_dir(directory: string);
var attr,
    i     : integer;
    dlist2: tstringlist;
    dir   : string;
begin
    dlist2:= tstringlist.create;
    filelist.items.clear;

    tb_prev.enabled:= false;
    f_fullscreen.m_prev.enabled:= false;
    m_prev.enabled:= false;

    attr:= fareadonly+fahidden+faarchive;
     dir:= directory;
     if f_pref.cb_acceptall.checked then do_rescan(dir, '*', attr, dlist2)
     else begin
      do_rescan(dir, 's',   attr, dlist2);
      do_rescan(dir, 'scr', attr, dlist2);
      do_rescan(dir, 'spc', attr, dlist2);
      do_rescan(dir, '$s',  attr, dlist2);
      do_rescan(dir, '$c',  attr, dlist2);
      do_rescan(dir, 'bin', attr, dlist2);
      if f_pref.e_userdefext.enabled then do_rescan(dir, f_pref.e_userdefext.text, attr, dlist2);
     end;
    for i:= 0 to dlist2.count-1 do filelist.items.add(dlist2.strings[i]);
    if filelist.items.count = 0 then
      messagebox(windowhandle,
                 'Sorry, there are no matching files in this folder.',
                 'SpecView SE',
                 MB_OK or MB_ICONERROR);
end;

procedure Tf_main.FormCreate(Sender: TObject);
var
    a,
    c,
    i    : integer;
    lkey : string;
    f    : textfile;
begin
     use_image:= false;
     lkey:= 'Software\HA\SpecView SE';

     filelist:= tlistbox.create(self);
     with filelist do begin
      parent:= f_main;
      visible:= false;
     end;

     if paramcount = 1 then
     if lowercase(paramstr(1)) = '--safe' then begin
        a:= 56;
        for i:= 0 to 6143 do pic_container[i]:= 0;
        for i:= 0 to 767 do pic_container[6145+i]:= a;
        color:= get_color(a, not(m_inv.checked));
        exit;
     end;

     if read_reg(HKEY_CURRENT_USER, lkey, 'FirstTime') = '0' then begin


      for i:= 1 to 15 do val(read_reg(HKEY_CURRENT_USER, lkey, 'Color'+inttostr(i)), spec_colors[i], c);


      if read_reg(HKEY_CURRENT_USER, lkey, 'ColorOFF') = '1' then begin
       m_color.checked:= true;
       colors_on:= false;
      end;

      if read_reg(HKEY_CURRENT_USER, lkey, 'BrightOFF') = '1' then begin
       m_bright.checked:= true;
       bright_on:= false;
      end;

      if read_reg(HKEY_CURRENT_USER, lkey, 'ProgressBarVisible') = '0' then
      m_hprogressclick(sender);

      if read_reg(HKEY_CURRENT_USER, lkey, 'ToolBarVisible') = '0' then
      m_htoolclick(sender);

      val(read_reg(HKEY_CURRENT_USER, lkey, 'WindowX'), a, c);
      left:= a;
      val(read_reg(HKEY_CURRENT_USER, lkey, 'WindowY'), a, c);
      top:= a;
      val(read_reg(HKEY_CURRENT_USER, lkey, 'WindowW'), a, c);
      width:= a;
      val(read_reg(HKEY_CURRENT_USER, lkey, 'WindowH'), a, c);
      height:= a;

      if read_reg(HKEY_CURRENT_USER, lkey, 'Maximized') = '1' then windowstate:= wsmaximized;

      if paramcount = 0 then begin
       if m_inv.checked then a:= 7 else a:= 56;
       if bright_on then a:=a+64;
       for i:= 0 to 6143 do pic_container[i]:= 0;
       for i:= 0 to 767 do pic_container[6145+i]:= a;
       color:= get_color(a, not(m_inv.checked));
      end;


     end else begin
      {$I-}
       if paramcount = 0 then begin
        if m_inv.checked then a:= 7 else a:= 56;
        if bright_on then a:=a+64;
        for i:= 0 to 6143 do pic_container[i]:= 0;
        for i:= 0 to 767 do pic_container[6145+i]:= a;
        color:= get_color(a, not(m_inv.checked));
       end;
       assignfile(f, extractfilepath(paramstr(0))+'slideshow\specview.shw');
       reset(f);
       if ioresult <> 0 then exit;
       closefile(f);
       filelist.items.loadfromfile(extractfilepath(paramstr(0))+'slideshow\specview.shw');
       for i:= 0 to filelist.items.count-1 do filelist.items[i]:= extractfilepath(paramstr(0))+filelist.items[i];
       filelist.items.savetofile(extractfilepath(paramstr(0))+'slideshow\specview.shw');
      {$I+}
     end;

end;

procedure Tf_main.m_registerClick(Sender: TObject);
begin
     f_pref.pc_pref.activepage:= f_pref.ts_ftypes;
     f_pref.showmodal;
end;

procedure Tf_main.m_palletteClick(Sender: TObject);
begin
     f_pref.pc_pref.activepage:= f_pref.ts_palette;
     f_pref.showmodal;
end;

procedure Tf_main.FormClose(Sender: TObject; var Action: TCloseAction);
var
   lkey : string;
   i    : byte;
begin
     lkey:= 'SOFTWARE\HA\SpecView SE';

     wrt_reg(HKEY_CURRENT_USER, lkey, 'FirstTime', '0', true);

     wrt_reg(HKEY_CURRENT_USER, lkey, 'WindowX', inttostr(top), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'WindowY', inttostr(left), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'WindowH', inttostr(height), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'WindowW', inttostr(width), true);

     for i:= 1 to 15 do wrt_reg(HKEY_CURRENT_USER, lkey, 'Color'+inttostr(i), inttostr(spec_colors[i]), true);

     wrt_reg(HKEY_CURRENT_USER, lkey, 'MRU', f_pref.de_favor.text, true);

     if windowstate = wsmaximized then wrt_reg(HKEY_CURRENT_USER, lkey, 'Maximized', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'Maximized', '0', true);

     if windowstate = wsmaximized then windowstate:= wsnormal;     

     if f_pref.cb_center.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'Center', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'Center', '0', true);

     if f_pref.cb_gs.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'GrayScale', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'GrayScale', '0', true);

     if f_pref.cb_scan.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'Rescan', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'Rescan', '0', true);

     if f_pref.cb_cdsk.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'DesktopIcon', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'DesktopIcon', '0', true);

     if f_pref.cb_cpg.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'ProgramGroup', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'ProgramGroup', '0', true);

     if f_pref.cb_csm.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'StartMenuIcon', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'StartMenuIcon', '0', true);

     for i:= 0 to 7 do
      if f_pref.clb_ftypes.checked[i] = true then wrt_reg(HKEY_CURRENT_USER, lkey, keyz[i+1], '1', true)
      else wrt_reg(HKEY_CURRENT_USER, lkey, keyz[i+1], '0', true);

     if f_pref.cb_userdefext.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'ExtUSER', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'ExtUSER', '0', true);

     if f_pref.cb_acceptall.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'AcceptAll', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'AcceptAll', '0', true);

     if f_pref.cb_defaultview.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'CheckDefault', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'CheckDefault', '0', true);

     if f_pref.cb_start.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'StartAuto', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'StartAuto', '0', true);

     if f_pref.cb_ex_as_chunx.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'ExportAsChunx', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'ExportAsChunx', '0', true);

     if f_pref.cb_savesl.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'SLSavePrompt', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'SLSavePrompt', '0', true);

     wrt_reg(HKEY_CURRENT_USER, lkey, 'HScale', inttostr(f_pref.tb_hscale.position), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'VScale', inttostr(f_pref.tb_vscale.position), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'TMargin', inttostr(f_pref.tb_tmargin.position), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'VMargin', inttostr(f_pref.tb_vmargin.position), true);

     if m_bright.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'BrightOFF', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'BrightOFF', '0', true);

     if m_color.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'ColorOFF', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'ColorOFF', '0', true);

     if m_inv.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'InverseON', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'InverseON', '0', true);

     if m_htool.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'ToolBarVisible', '0', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'ToolBarVisible', '1', true);

     if m_hprogress.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'ProgressBarVisible', '0', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'ProgressBarVisible', '1', true);

     if m_full.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'FullScreenMode', '0', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'FullScreenMode', '1', true);

     wrt_reg(HKEY_CURRENT_USER, lkey, 'SLEtop', inttostr(f_sledit.top), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'SLEleft', inttostr(f_sledit.left), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'SLEwidth', inttostr(f_sledit.width), true);
     wrt_reg(HKEY_CURRENT_USER, lkey, 'SLEheight', inttostr(f_sledit.height), true);
     if f_sledit.m_useinstead.checked then wrt_reg(HKEY_CURRENT_USER, lkey, 'Instead', '1', true)
     else wrt_reg(HKEY_CURRENT_USER, lkey, 'Instead', '0', true);

     if (f_sledit.lbx_list.items.count > 0) and (f_pref.cb_savesl.checked) then
      case messagebox(windowhandle,
                      'Do you want to save SlideList before exit?',
                      'SpecView SE',
                      MB_ICONQUESTION or MB_YESNO) of
      idyes:    f_sledit.tb_saveclick(sender);
     end;
end;

procedure Tf_main.m_brightClick(Sender: TObject);
begin
     bright_on:= not(bright_on);
     m_bright.checked:= not(m_bright.checked);
     makepic(container_size);
end;

procedure Tf_main.m_htoolClick(Sender: TObject);
var
   sign : integer;
begin
     sign:= - 1;
     t_main.visible:= not(t_main.visible);
     m_htool.checked:= not(m_htool.checked);
     if t_main.visible then sign:= 1;
     height:= height+t_main.height*sign;
end;

procedure Tf_main.m_hprogressClick(Sender: TObject);
var
   sign : integer;
begin
     sign:= - 1;
     pn_progress.visible:= not(pn_progress.visible);
     m_hprogress.checked:= not(m_hprogress.checked);
     if pn_progress.visible then sign:= 1;
     height:= height+pn_progress.height*sign;
end;

procedure Tf_main.m_printClick(Sender: TObject);
begin
     if dlg_print.execute then begin
      with printer do begin
       caption:= f_main.caption;
       begindoc;
       canvas.stretchdraw(rect(
                        f_pref.tb_vmargin.position,
                        f_pref.tb_tmargin.position,
                        f_pref.tb_vmargin.position+256*f_pref.tb_hscale.position,
                        f_pref.tb_tmargin.position+192*f_pref.tb_vscale.position),
                        i_speccy.picture.graphic);
       enddoc;
      end;
     end;
end;

procedure Tf_main.tb_exportClick(Sender: TObject);
var
   tmp_img : timage;
begin
    tmp_img:= timage.create(self);
    with tmp_img do begin
     parent:= f_main;
     visible:= false;
     stretch:= true;
     if f_pref.cb_ex_as_chunx.checked then begin
      width:=  64;
      height:= 48;
      if not(m_color.checked) then tb_discardClick(sender);
      getchunx(i_speccy, tmp_img);
     end else begin
      width:=  256;
      height:= 192;
      tmp_img:= i_speccy;
     end;
    end;
     with dlg_save do
     if execute then begin
      case filterindex of
    0..1: begin
           if extractfileext(filename)= '' then filename:= filename+'.bmp';
           tmp_img.picture.savetofile(filename);
          end;
       2: begin
           if extractfileext(filename)= '' then filename:= filename+'.jpg';
           saveJPEG(filename, tmp_img);
          end;
       3: begin
           if extractfileext(filename)= '' then filename:= filename+'.gif';
           saveGIF(filename, tmp_img);
          end;
      end;
     end;
end;

procedure Tf_main.m_shortcutsClick(Sender: TObject);
begin
     f_pref.pc_pref.activepage:= f_pref.ts_short;
     f_pref.showmodal;
end;

procedure Tf_main.m_docsClick(Sender: TObject);
begin
     executefile(extractfilepath(paramstr(0))+'docs\readmain.html','','',SW_SHOWMAXIMIZED);
end;

procedure Tf_main.m_homeClick(Sender: TObject);
begin
     executefile(extractfilepath(paramstr(0))+'web\ha.url','','',SW_SHOWMAXIMIZED);
end;

procedure Tf_main.rescan_it(const flist: tlistbox; const sender: tobject);
begin
     flist.itemindex:= 0;
     if flist.items.count < 1 then begin
      tb_next.enabled:= false;
      tb_prev.enabled:= false;
      f_fullscreen.m_prev.enabled:= false;
      m_prev.enabled:= false;
      f_fullscreen.m_next.enabled:= false;
      m_next.enabled:= false;
      messagebox(windowhandle,
                 'Sorry, there are no matching files...',
                 'SpecView SE',
                 MB_ICONERROR or MB_OK);
      exit;
     end else begin
      if flist.items.count > 1 then begin
       tb_next.enabled:= true;
       f_fullscreen.m_prev.enabled:= true;
       m_prev.enabled:= true;
       f_fullscreen.m_next.enabled:= true;
       m_next.enabled:= true;
      end;
      if sender <> f_pref then begin
       container_size:= readfile(flist.items[0]);
       if (container_size = 0) or (container_size > 6929) then
        messagebox(windowhandle,
                   pchar(flist.items[0]+' ('+inttostr(container_size)+' bytes) - '+m_corr),
                   'SpecView SE',
                   MB_OK or MB_ICONERROR)
       else begin
        makepic(container_size);
        f_main.caption:= flist.items[0]+' - SpecView SE';
        application.title:= flist.items[0]+' - SpecView SE';
       end;
      end;
      end;
end;

procedure Tf_main.tb_rescanClick(Sender: TObject);
begin
     if m_usesl.checked then begin
      rescan_it(f_sledit.lbx_list, sender);
      exit;
     end;
     filelist.items.clear;
     rescan_dir(f_pref.de_favor.text);
     rescan_it(filelist, sender);
end;

procedure Tf_main.prev_p(const flist: tlistbox);
begin
     if flist.items.count = 0 then exit;
     flist.itemindex:= flist.itemindex-1;
     if flist.itemindex <= 0 then begin
      flist.itemindex:= 0;
      tb_prev.enabled:= false;
      f_fullscreen.m_prev.enabled:= false;
      m_prev.enabled:= false;
     end;
     tb_next.enabled:= true;
     f_fullscreen.m_next.enabled:= true;
     m_next.enabled:= true;
     container_size:= readfile(flist.items[flist.itemindex]);
     if (container_size = 0) or (container_size > 6929) then
      messagebox(windowhandle,
                 pchar(flist.items[flist.itemindex]+' - '+m_corr),
                 'SpecView SE',
                 MB_OK or MB_ICONERROR)
     else begin
      makepic(container_size);
      f_main.caption:= flist.items[flist.itemindex]+' - SpecView SE';
      application.title:= flist.items[flist.itemindex]+' - SpecView SE';
     end;

end;

procedure Tf_main.tb_prevClick(Sender: TObject);
begin
     if m_usesl.checked then prev_p(f_sledit.lbx_list)
     else prev_p(filelist);
end;

procedure Tf_main.next_p(const flist: tlistbox);
begin
     if flist.items.count = 0 then exit;
     if flist.itemindex >= (flist.items.count-1) then begin
      tb_next.enabled:= false;
      f_fullscreen.m_next.enabled:= false;
      m_next.enabled:= false;
      flist.itemindex:= flist.items.count-1;
     end;
     tb_prev.enabled:= true;
     f_fullscreen.m_prev.enabled:= true;
     m_prev.enabled:= true;
     container_size:= readfile(flist.items[flist.itemindex]);

     if (container_size = 0) or (container_size > 6929) then
      messagebox(windowhandle,
                 pchar(flist.items[flist.itemindex]+' - '+m_corr),
                 'SpecView SE',
                 MB_OK or MB_ICONERROR)
     else begin
      makepic(container_size);
      f_main.caption:= flist.items[flist.itemindex]+' - SpecView SE';
      application.title:= flist.items[flist.itemindex]+' - SpecView SE';
     end;
end;

procedure Tf_main.tb_nextClick(Sender: TObject);
begin
     if m_usesl.checked then begin
      f_sledit.lbx_list.itemindex:= f_sledit.lbx_list.itemindex+1;
      next_p(f_sledit.lbx_list);
     end else begin
      filelist.itemindex:= filelist.itemindex+1;
      next_p(filelist);
     end;
end;

procedure Tf_main.m_sleditClick(Sender: TObject);
begin
     f_sledit.show;
end;

procedure Tf_main.m_useslClick(Sender: TObject);
begin
     m_usesl.checked:= not(m_usesl.checked);
     f_sledit.m_useinstead.checked:= not(f_sledit.m_useinstead.checked);
end;

procedure Tf_main.m_invClick(Sender: TObject);
begin
        m_inv.checked:= not(m_inv.checked);
        pb_progress.position:= 0;
        makepic(container_size);
end;

procedure Tf_main.walldesk(style: byte);
//style 0 : centered; 1: tiled; 2: stretch; 3: remove any wallpaper
var
   s,
   s1,
   fname : string;
begin
     case style of
      0: begin s:= '0'; s1:= '0'; end;
      1: begin s:= '0'; s1:= '1'; end;
      2: begin s:= '2'; s1:= '0'; end;
      3: begin s:= '0'; s1:= '0'; end;
     end;
     if (style = 3) then fname:= ''
     else begin
      fname:= extractfilepath(paramstr(0))+'tmp\SpecView SE Wallpaper.bmp';
      i_speccy.Picture.SaveToFile(fname);
     end;
     wrt_reg(HKEY_CURRENT_USER, 'Control Panel\Desktop\', 'WallpaperStyle', s, true);
     wrt_reg(HKEY_CURRENT_USER, 'Control Panel\Desktop\', 'TileWallpaper', s1, true);
     wrt_reg(HKEY_CURRENT_USER, 'Control Panel\Desktop\', 'Wallpaper', fname, true);
     SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, Nil, SPIF_SENDWININICHANGE );
end;

procedure Tf_main.m_wtiledClick(Sender: TObject);
begin
     walldesk(1);
end;

procedure Tf_main.m_wcenteredClick(Sender: TObject);
begin
     walldesk(0);
end;

procedure Tf_main.Stretch1Click(Sender: TObject);
begin
     walldesk(2);
end;

procedure Tf_main.m_rmvClick(Sender: TObject);
begin
     walldesk(3);
end;

procedure Tf_main.m_expfolderClick(Sender: TObject);
var
   i : integer;
begin
     if filelist.items.count < 1 then begin
      messagebox(0,
                 pchar('Nothing to export because the MRU folder is empty or not scanned.'),
                 pchar('SpecView SE'),
                 MB_OK or MB_ICONERROR
                 );
      exit;
     end;
     if f_sledit.lbx_list.items.count > 0 then
     if messagebox(0,
                   pchar('Add folder content to existing SlideList?'),
                   pchar('SpecView SE'),
                   MB_YESNO or MB_ICONQUESTION
                   ) = idno then exit;
     for i:= 0 to filelist.items.count-1 do f_sledit.lbx_list.items.add(filelist.items[i]);
     f_sledit.upd_stbar;
     messagebox(0,
                pchar('Folder content was successfully exported.'),
                pchar('SpecView SE'),
                MB_OK or MB_ICONINFORMATION
                );
end;

end.

