unit sledit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Menus, ComCtrls, ToolWin, ImgList;

type
  Tf_sledit = class(TForm)
    tb_sledit: TToolBar;
    stb_total: TStatusBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    N1: TMenuItem;
    lbx_list: TListBox;
    il_sledit: TImageList;
    tb_open: TToolButton;
    tb_save: TToolButton;
    tb_export: TToolButton;
    ToolButton4: TToolButton;
    tb_remove: TToolButton;
    tb_insert: TToolButton;
    dlg_open: TOpenDialog;
    OpenSlideList1: TMenuItem;
    m_save: TMenuItem;
    N2: TMenuItem;
    Exportselectedfiles1: TMenuItem;
    N3: TMenuItem;
    m_close: TMenuItem;
    Tools1: TMenuItem;
    m_ins: TMenuItem;
    m_del: TMenuItem;
    N4: TMenuItem;
    m_sorted: TMenuItem;
    SlideListeditorreference1: TMenuItem;
    N5: TMenuItem;
    m_useinstead: TMenuItem;
    dlg_save: TSaveDialog;
    ToolButton1: TToolButton;
    tb_up: TToolButton;
    tb_dn: TToolButton;
    m_up: TMenuItem;
    m_down: TMenuItem;
    m_selectwhole: TMenuItem;
    procedure tb_openClick(Sender: TObject);
    procedure tb_insertClick(Sender: TObject);
    procedure tb_removeClick(Sender: TObject);
    procedure m_sortedClick(Sender: TObject);
    procedure tb_saveClick(Sender: TObject);
    procedure m_useinsteadClick(Sender: TObject);
    procedure lbx_listDblClick(Sender: TObject);
    procedure m_closeClick(Sender: TObject);
    procedure tb_exportClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure SlideListeditorreference1Click(Sender: TObject);
    procedure tb_upClick(Sender: TObject);
    procedure tb_dnClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure parseTRD(filename: string);
    procedure parseSCL(filename: string);    
    procedure upd_stbar;
    procedure readshow(filename: string);
  end;

var
  f_sledit: Tf_sledit;

implementation

uses main, export, reguse, pref, FmxUtils, constants;

{$R *.DFM}

procedure Tf_sledit.upd_stbar;
begin
     stb_total.simpletext:= 'Files total: '+inttostr(lbx_list.items.count);
end;

procedure Tf_sledit.parseTRD(filename: string);
var
   f1 : file;
   s  : string;
   bf : array [1..4096] of byte;
   fc,
   j  : byte;
   i  : word;
begin
       assignfile(f1, filename);
       reset(f1, 4096);
       if ioresult <> 0 then begin
        messagebox(f_sledit.windowhandle,
                   pchar('Error reading '+filename),
                   'SpecView SE',
                   MB_ICONERROR or MB_OK);
        exit;
       end;
       blockread(f1, bf, 1);
       closefile(f1);
       fc:= bf[$8e5]; // filez count in an image
       if fc = 0 then begin
                       messagebox(f_sledit.windowhandle,
                       pchar('Image '+filename+' contains no files.'),
                       'SpecView SE',
                       MB_ICONERROR or MB_OK);
                       exit;
       end;
       if (bf[$8e8] <> $10) then begin
                       messagebox(f_sledit.windowhandle,
                       pchar('Image '+filename+' is probably corrupted.'),
                       'SpecView SE',
                       MB_ICONERROR or MB_OK);
                       exit;
       end;
       for i:= 1 to fc do begin
        //parse TRD image
         if (bf[$0E+ $10*(i-1)] = 24) or (bf[$0E+ $10*(i-1)] = 27) then begin
          s:= '';
          for j:= 1 to 9 do s:= s+char(bf[$10*(i-1)+j]);
          s:= s+';'+inttostr(bf[$0E+ $10*(i-1)])+';'+inttostr(bf[$0F+$10*(i-1)]*256+4096*bf[$10+ $10*(i-1)]);
          lbx_list.items.add(s);
         end;
       end;
       use_image:= true;
       m_save.enabled:= false;
       tb_save.enabled:= false;
       m_ins.enabled:= false;
       tb_insert.enabled:= false;
end;

procedure Tf_sledit.parseSCL(filename: string);
var
   f1   : file;
   s    : string;
   bf   : array [1..4096] of byte;
   fc,
   j,
   k    : byte;
   flng,
   where: dword;
begin
       assignfile(f1, filename);
       reset(f1, 4096);
       if ioresult <> 0 then begin
        messagebox(f_sledit.windowhandle,
                   pchar('Error reading '+filename),
                   'SpecView SE',
                   MB_ICONERROR or MB_OK);
        exit;
       end;
       blockread(f1, bf, 1);
       closefile(f1);
       fc:= bf[$09]; //files count in a SCL
       if (fc = 0) then begin
                       messagebox(f_sledit.windowhandle,
                       pchar('Image '+filename+' contains no images or corrupted.'),
                       'SpecView SE',
                       MB_ICONERROR or MB_OK);
                       exit;
       end;
       where:= 9+14*fc;
       for j:= 1 to fc do begin
        flng:= bf[14*(j-1)+9+12]+256*bf[14*(j-1)+13+9];
        if (flng = 6144) or (flng = 6912) then begin
         s:= '';
         for k:= 1 to 9 do s:= s+char(bf[(j-1)*14+9+k]);
         s:= s+';'+inttostr(bf[14*(j-1)+13+9])+';'+inttostr(where);
         lbx_list.items.add(s);
        end;
        where:= flng+where;
       end;
       use_image:= true;
       m_save.enabled:= false;
       tb_save.enabled:= false;
       m_ins.enabled:= false;
       tb_insert.enabled:= false;
end;

procedure Tf_sledit.readshow(filename: string);
var
   f  : textfile;
   s  : string;
begin
      {$I-}
      f_sledit.lbx_list.items.clear;
      if lowercase(extractfileext(filename))= '.shw' then begin
       assignfile(f, filename);
       reset(f);
       if ioresult <> 0 then begin
        messagebox(f_sledit.windowhandle,
                   pchar('Error reading '+filename),
                   'SpecView SE',
                   MB_ICONERROR or MB_OK);
        exit;
       end;
       m_save.enabled:= true;
       tb_save.enabled:= true;
       m_ins.enabled:= true;
       tb_insert.enabled:= true;
       while not(eof(f)) do begin
        readln(f, s);
        if ioresult <> 0 then begin
         messagebox(f_sledit.windowhandle,
                    pchar('Error reading '+filename),
                    'SpecView SE',
                    MB_ICONERROR or MB_OK);
         exit;
        end;
        if s[1] <> ';' then f_sledit.lbx_list.items.add(s);
       end;
       closefile(f);
       use_image:= false;
      end else if (lowercase(extractfileext(filename))= '.trd') then parseTRD(filename)
      else if (lowercase(extractfileext(filename))= '.scl') then parseSCL(filename)
      else messagebox(f_sledit.windowhandle,
                    pchar(filename+': file format is not supported.'),
                    'SpecView SE',
                    MB_ICONERROR or MB_OK);
      if lbx_list.items.count < 1 then messagebox(f_sledit.windowhandle,
                    pchar(filename+' probably contains no pictures.'),
                    'SpecView SE',
                    MB_ICONWARNING or MB_OK);
      application.title:= '[SLIDELIST LOADED] - '+filename+' - SpecView SE';
      f_main.caption:= '[SLIDELIST LOADED] - '+filename+' - SpecView SE';
      caption:= filename+' - SlideList Editor';
      {$I+}
end;

procedure Tf_sledit.tb_openClick(Sender: TObject);
begin
     dlg_open.filter:= 'SlideList Editor files (*.shw; *.trd; *.scl)|*.shw;*.trd;*.scl|All files (*.*)|*.*';
     if dlg_open.execute then begin
      readshow(dlg_open.filename);
      upd_stbar;
      if f_pref.cb_start.checked then begin
       f_main.m_usesl.checked:= true;
       m_useinstead.checked:= true;
       f_main.tb_rescanclick(sender);
      end;
     end;
end;

procedure Tf_sledit.tb_insertClick(Sender: TObject);
begin
     dlg_open.filter:= 'Speccy pictures (*.s; *.scr; *.spc; *.bin; *.$c; *.$s)|*.s; *.scr; *.spc; *.bin; *.$c; *.$s|All files (*.*)|*.*';
     if dlg_open.execute then begin
      lbx_list.items.add(dlg_open.filename);
     end;
     upd_stbar;
end;

procedure Tf_sledit.tb_removeClick(Sender: TObject);
var
   i : integer;     
begin
     with lbx_list do begin
      if items.count < 1 then exit;
      for i:= items.count-1 downto 0 do if i < items.count then if selected[i] then items.Delete(i);
     end;
     upd_stbar;
end;

procedure Tf_sledit.m_sortedClick(Sender: TObject);
begin
     m_sorted.checked:= not(m_sorted.checked);
     lbx_list.sorted:= m_sorted.checked;
end;

procedure Tf_sledit.tb_saveClick(Sender: TObject);
begin
     lbx_list.items.clear;
     if dlg_save.execute then lbx_list.items.savetofile(dlg_save.filename);
end;

procedure Tf_sledit.m_useinsteadClick(Sender: TObject);
begin
     f_main.m_usesl.checked:= not(f_main.m_usesl.checked);
     m_useinstead.checked:= not(m_useinstead.checked);
end;

procedure Tf_sledit.lbx_listDblClick(Sender: TObject);
var
   i : integer;
begin
     for i:= 0 to lbx_list.items.count-1 do lbx_list.selected[i]:= true;
end;

procedure Tf_sledit.m_closeClick(Sender: TObject);
begin
     close;
end;

procedure Tf_sledit.tb_exportClick(Sender: TObject);
begin
     f_export.showmodal;
end;

procedure Tf_sledit.FormClose(Sender: TObject; var Action: TCloseAction);
var
   lkey : string;
begin
     lkey:= 'Software\HA\SpecView SE';
end;

procedure Tf_sledit.FormCreate(Sender: TObject);
var
   a,
   c    : integer;
   lkey : string;
begin
     if paramcount = 1 then
     if lowercase(paramstr(1)) = '--safe' then exit;

     lkey:= 'Software\HA\SpecView SE';
     lbx_list.itemindex:= 0;

     if read_reg(HKEY_CURRENT_USER, lkey, 'FirstTime') = '0' then begin

     if read_reg(HKEY_CURRENT_USER, lkey, 'Instead') = '1' then begin
      f_main.m_usesl.checked:= true;
      m_useinstead.checked:= true;
     end;
     val(read_reg(HKEY_CURRENT_USER, lkey, 'SLEleft'), a, c);
     left:= a;
     val(read_reg(HKEY_CURRENT_USER, lkey, 'SLEtop'), a, c);
     top:= a;
     val(read_reg(HKEY_CURRENT_USER, lkey, 'SLEwidth'), a, c);
     width:= a;
     val(read_reg(HKEY_CURRENT_USER, lkey, 'SLEheight'), a, c);
     height:= a;
     end;

     if f_pref.cb_scan.checked then begin
      f_main.tb_rescanclick(sender);
     end;

     if paramcount >0 then
      if (lowercase(extractfileext(paramstr(1))) = '.shw')  or (lowercase(extractfileext(paramstr(1))) = '.trd') or (lowercase(extractfileext(paramstr(1))) = '.scl') then begin
       dlg_open.filename:= paramstr(1);
       readshow(paramstr(1));
        f_main.m_usesl.checked:= true;
        m_useinstead.checked:= true;
        if f_pref.cb_start.checked then f_main.tb_rescanclick(sender);
      end;
end;

procedure Tf_sledit.SlideListeditorreference1Click(Sender: TObject);
begin
     executefile(extractfilepath(paramstr(0))+'docs\readsle.html','','',SW_SHOWMAXIMIZED);
end;

procedure Tf_sledit.tb_upClick(Sender: TObject);
var
   s : string;
begin
     with lbx_list do begin
      if (items.count = 0) or
         (itemindex   < 1) then exit;

      s:= items[itemindex];

      items[itemindex]:= items[itemindex - 1];

      items[itemindex-1]:= s;

      itemindex:= itemindex-1;

     end;
end;

procedure Tf_sledit.tb_dnClick(Sender: TObject);
var
   s : string;
begin
     with lbx_list do begin
      if (items.count = 0) or
         (itemindex   > items.count-2) then exit;

      s:= items[itemindex];

      items[itemindex]:= items[itemindex + 1];

      items[itemindex+1]:= s;

      itemindex:= itemindex+1;

     end;
end;

end.
